gcc_update revision 1.1.1.15 1 1.1 mrg #! /bin/sh
2 1.1 mrg #
3 1.1.1.2 mrg # Update a local Subversion, Git or Mercurial tree from the GCC
4 1.1.1.2 mrg # repository, with an emphasis on treating generated files correctly, so
5 1.1.1.2 mrg # that autoconf, gperf et al are not required for the ``end'' user.
6 1.1 mrg #
7 1.1.1.15 mrg # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8 1.1.1.7 mrg # 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9 1.1.1.7 mrg # Originally by Gerald Pfeifer <gerald (at] pfeifer.com>, August 1998.
10 1.1 mrg #
11 1.1 mrg # This script is Free Software, and it can be copied, distributed and
12 1.1 mrg # modified as defined in the GNU General Public License. A copy of
13 1.1 mrg # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 1.1 mrg #
15 1.1 mrg #
16 1.1.1.2 mrg # By default all command-line options are passed to `svn update` or `hg/git
17 1.1.1.2 mrg # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 1.1 mrg # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 1.1 mrg # are omitted.
20 1.1 mrg #
21 1.1 mrg # If the first parameter reads --patch, the second parameter is considered
22 1.1 mrg # a patch file.
23 1.1 mrg #
24 1.1 mrg # If the first parameter is --touch, no svn operation will be performed,
25 1.1 mrg # only generated files that appear to be out of date in the local tree
26 1.1 mrg # will be touched.
27 1.1 mrg #
28 1.1 mrg # If the first parameter is --list, a list of the generated files and
29 1.1 mrg # their dependencies will be printed; --help prints this message.
30 1.1 mrg #
31 1.1 mrg # If the first parameter is --silent, this script prints nothing other
32 1.1 mrg # than error messages; the second parameter is then interpreted as above.
33 1.1 mrg #
34 1.1 mrg # Examples:
35 1.1 mrg #
36 1.1 mrg # contrib/gcc_update -r 8712
37 1.1 mrg # contrib/gcc_update --patch some-patch
38 1.1 mrg # contrib/gcc_update --touch
39 1.1 mrg # contrib/gcc_update --list
40 1.1 mrg
41 1.1 mrg
42 1.1.1.2 mrg # Default options used when updating (none).
43 1.1 mrg UPDATE_OPTIONS=""
44 1.1 mrg
45 1.1.1.2 mrg # Set the locale to C to make this script work for users with foreign
46 1.1.1.2 mrg # locale like e.g. French UTF-8.
47 1.1.1.2 mrg LANG=C
48 1.1.1.2 mrg LC_ALL=C
49 1.1.1.2 mrg export LANG LC_ALL
50 1.1.1.2 mrg
51 1.1 mrg ######## Anything below shouldn't be changed by regular users.
52 1.1 mrg
53 1.1 mrg # Arrange for the value of $0 to be available for functions
54 1.1 mrg self=$0
55 1.1 mrg
56 1.1 mrg # This function prints its arguments to standard output unless
57 1.1 mrg # "silent" is set.
58 1.1 mrg unset silent
59 1.1 mrg chat () {
60 1.1 mrg if [ -z "$silent" ]; then
61 1.1 mrg echo "$@"
62 1.1 mrg fi
63 1.1 mrg }
64 1.1 mrg
65 1.1 mrg # This function prints a list of all generated files, along with their
66 1.1 mrg # dependencies. Note that only one target is supported per line: the
67 1.1 mrg # colon is stripped from the output.
68 1.1 mrg files_and_dependencies () {
69 1.1 mrg sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 1.1 mrg # fixincludes
71 1.1 mrg fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 1.1 mrg fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 1.1.1.15 mrg fixincludes/fixincl.x: fixincludes/inclhack.def fixincludes/fixincl.tpl
74 1.1 mrg # intl library
75 1.1 mrg intl/plural.c: intl/plural.y
76 1.1.1.13 mrg intl/plural-config.h: intl/plural.y
77 1.1 mrg intl/configure: intl/configure.ac intl/aclocal.m4
78 1.1 mrg intl/config.h.in: intl/configure.ac intl/aclocal.m4
79 1.1 mrg # Now, proceed to gcc automatically generated files
80 1.1 mrg gcc/configure: gcc/configure.ac
81 1.1 mrg gcc/cstamp-h.in: gcc/configure.ac
82 1.1 mrg gcc/config.in: gcc/cstamp-h.in
83 1.1 mrg gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
84 1.1.1.3 mrg gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
85 1.1.1.7 mrg gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
86 1.1.1.7 mrg gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
87 1.1.1.2 mrg gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
88 1.1.1.2 mrg gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
89 1.1.1.2 mrg gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
90 1.1.1.14 mrg gcc/config/loongarch/loongarch-str.h: gcc/config/loongarch/genopts/genstr.sh gcc/config/loongarch/genopts/loongarch-strings
91 1.1.1.14 mrg gcc/config/loongarch/loongarch.opt: gcc/config/loongarch/genopts/genstr.sh gcc/config/loongarch/genopts/loongarch.opt.in
92 1.1.1.2 mrg gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
93 1.1.1.2 mrg gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
94 1.1.1.2 mrg gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
95 1.1.1.14 mrg gcc/config/rs6000/fusion.md: gcc/config/rs6000/genfusion.pl
96 1.1 mrg # And then, language-specific files
97 1.1 mrg gcc/cp/cfns.h: gcc/cp/cfns.gperf
98 1.1.1.15 mrg gcc/cp/std-name-hint.h: gcc/cp/std-name-hint.gperf
99 1.1.1.15 mrg gcc/cp/std-name-hint.gperf: gcc/cp/cxxapi-data.csv
100 1.1.1.15 mrg gcc/m2/configure: gcc/m2/configure.ac
101 1.1.1.15 mrg gcc/m2/gm2config.h.in: gcc/m2/configure.ac
102 1.1.1.15 mrg gcc/m2/gm2-libs/config-host: gcc/m2/gm2-libs/config-host.in
103 1.1 mrg # testsuite
104 1.1 mrg # Without this, _Pragma3.c can have a false negative.
105 1.1 mrg gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
106 1.1 mrg # Similarly, without this, you will see:
107 1.1 mrg # direct2s.c:35: warning: current file is older than direct2.c
108 1.1 mrg gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
109 1.1 mrg # lto-plugin
110 1.1.1.15 mrg lto-plugin/aclocal.m4: lto-plugin/configure.ac
111 1.1 mrg lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
112 1.1 mrg lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
113 1.1.1.14 mrg # tools
114 1.1.1.14 mrg c++tools/configure: c++tools/configure.ac
115 1.1.1.14 mrg c++tools/config.h.in: c++tools/configure.ac
116 1.1 mrg # And libraries, at last
117 1.1 mrg libbanshee/configure: libbanshee/configure.ac
118 1.1 mrg libmudflap/configure: libmudflap/configure.ac
119 1.1 mrg libobjc/configure: libobjc/configure.ac
120 1.1 mrg zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
121 1.1 mrg zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
122 1.1 mrg zlib/configure: zlib/configure.ac zlib/aclocal.m4
123 1.1 mrg fastjar/aclocal.m4: fastjar/configure.ac
124 1.1 mrg fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
125 1.1 mrg fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
126 1.1 mrg boehm-gc/aclocal.m4: boehm-gc/configure.ac
127 1.1 mrg boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
128 1.1 mrg boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
129 1.1 mrg libada/configure: libada/configure.ac
130 1.1 mrg libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
131 1.1 mrg libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
132 1.1 mrg libffi/configure: libffi/configure.ac libffi/aclocal.m4
133 1.1 mrg libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
134 1.1 mrg libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
135 1.1 mrg libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
136 1.1.1.15 mrg libgm2/Makefile.in: libgm2/Makefile.am libgm2/configure.ac libgm2/aclocal.m4
137 1.1.1.15 mrg libgm2/aclocal.m4: libgm2/configure.ac
138 1.1.1.15 mrg libgm2/libm2cor/Makefile.in: libgm2/libm2cor/Makefile.am
139 1.1.1.15 mrg libgm2/libm2pim/Makefile.in: libgm2/libm2pim/Makefile.am
140 1.1.1.15 mrg libgm2/libm2iso/Makefile.in: libgm2/libm2iso/Makefile.am
141 1.1.1.15 mrg libgm2/libm2log/Makefile.in: libgm2/libm2log/Makefile.am
142 1.1.1.15 mrg libgm2/libm2min/Makefile.in: libgm2/libm2min/Makefile.am
143 1.1.1.2 mrg libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
144 1.1.1.2 mrg libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
145 1.1.1.2 mrg libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
146 1.1 mrg libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
147 1.1.1.14 mrg libcody/configure: libcody/configure.ac libcody/config.m4
148 1.1 mrg libcpp/aclocal.m4: libcpp/configure.ac
149 1.1 mrg libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
150 1.1 mrg libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
151 1.1 mrg libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
152 1.1.1.3 mrg libgomp/Makefile.am: libgomp/plugin/Makefrag.am
153 1.1 mrg libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
154 1.1.1.3 mrg libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
155 1.1.1.3 mrg libgomp/configure.ac: libgomp/plugin/configfrag.ac
156 1.1 mrg libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
157 1.1 mrg libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
158 1.1.1.15 mrg libgrust/Makefile.in: libgrust/Makefile.am libgrust/aclocal.m4
159 1.1.1.15 mrg libgrust/aclocal.m4: libgrust/configure.ac
160 1.1.1.15 mrg libgrust/configure: libgrust/configure.ac libgrust/aclocal.m4
161 1.1.1.15 mrg libgrust/libproc_macro_internal/Makefile.in: libgrust/libproc_macro_internal/Makefile.am libgrust/aclocal.m4
162 1.1.1.2 mrg libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
163 1.1.1.2 mrg libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
164 1.1.1.2 mrg libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
165 1.1.1.2 mrg libitm/configure: libitm/configure.ac libitm/aclocal.m4
166 1.1.1.2 mrg libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
167 1.1.1.2 mrg libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
168 1.1.1.2 mrg libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
169 1.1.1.2 mrg libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
170 1.1.1.2 mrg libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
171 1.1.1.2 mrg libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
172 1.1.1.2 mrg libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
173 1.1.1.2 mrg libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
174 1.1.1.2 mrg libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
175 1.1.1.2 mrg libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
176 1.1.1.2 mrg libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
177 1.1.1.2 mrg libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
178 1.1.1.3 mrg libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
179 1.1.1.3 mrg libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
180 1.1.1.3 mrg libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
181 1.1.1.6 mrg libbacktrace/aclocal.m4: libbacktrace/configure.ac
182 1.1.1.6 mrg libbacktrace/Makefile.in: libbacktrace/Makefile.am libbacktrace/aclocal.m4
183 1.1.1.6 mrg libbacktrace/configure: libbacktrace/configure.ac libbacktrace/aclocal.m4
184 1.1.1.6 mrg libbacktrace/config.h.in: libbacktrace/configure.ac libbacktrace/aclocal.m4
185 1.1.1.12 mrg libphobos/Makefile.in: libphobos/Makefile.am libphobos/configure.ac libphobos/aclocal.m4
186 1.1.1.12 mrg libphobos/aclocal.m4: libphobos/configure.ac libphobos/acinclude.m4
187 1.1.1.12 mrg libphobos/config.h.in: libphobos/configure.ac libphobos/aclocal.m4
188 1.1.1.12 mrg libphobos/configure: libphobos/configure.ac libphobos/aclocal.m4
189 1.1.1.12 mrg libphobos/src/Makefile.in: libphobos/src/Makefile.am libphobos/aclocal.m4
190 1.1.1.12 mrg libphobos/testsuite/Makefile.in: libphobos/testsuite/Makefile.am libphobos/aclocal.m4
191 1.1.1.15 mrg libstdc++-v3/aclocal.m4: libstdc++-v3/configure.ac libstdc++-v3/acinclude.m4
192 1.1.1.15 mrg libstdc++-v3/Makefile.in: libstdc++-v3/Makefile.am libstdc++-v3/aclocal.m4
193 1.1.1.15 mrg libstdc++-v3/configure: libstdc++-v3/configure.ac libstdc++-v3/acinclude.m4
194 1.1.1.15 mrg libstdc++-v3/include/bits/version.h: libstdc++-v3/include/bits/version.def libstdc++-v3/include/bits/version.tpl
195 1.1.1.15 mrg libcc1/aclocal.m4: libcc1/configure.ac
196 1.1.1.15 mrg libcc1/Makefile.in: libcc1/Makefile.am libcc1/configure.ac libcc1/aclocal.m4
197 1.1.1.15 mrg libcc1/configure: libcc1/configure.ac
198 1.1 mrg # Top level
199 1.1 mrg Makefile.in: Makefile.tpl Makefile.def
200 1.1 mrg configure: configure.ac config/acx.m4
201 1.1 mrg EOF
202 1.1 mrg }
203 1.1 mrg
204 1.1 mrg
205 1.1 mrg # This function touches generated files such that the ``end'' user does
206 1.1 mrg # not have to rebuild them.
207 1.1 mrg touch_files () {
208 1.1 mrg rm -f Makefile.$$
209 1.1 mrg echo 'all: \' > Makefile.$$
210 1.1 mrg files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
211 1.1 mrg echo '; @true' >> Makefile.$$
212 1.1 mrg files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
213 1.1 mrg files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
214 1.1 mrg echo ':' >> Makefile.$$
215 1.1 mrg echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
216 1.1 mrg echo ' echo Touching $@...; \' >> Makefile.$$
217 1.1 mrg chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
218 1.1 mrg echo ' touch $@' >> Makefile.$$
219 1.1 mrg files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
220 1.1 mrg
221 1.1 mrg # We would have to explicitly shut off the "Entering... Leaving..."
222 1.1 mrg # messages through "--no-print-directory" to handle the case when
223 1.1 mrg # we were called from a recursive invocation (i.e. "$(MAKE)" in a
224 1.1 mrg # Makefile, not just make). Passing only "-s" doesn't help then,
225 1.1 mrg # because make has helpfully added "-w" to MAKEFLAGS automatically.
226 1.1 mrg # Unfortunately we do not require GNU make other than for building
227 1.1 mrg # and testing, so let's just grep known text explicitly echoed by
228 1.1 mrg # the rule.
229 1.1 mrg while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
230 1.1 mrg sleep 1
231 1.1 mrg done 2>&1
232 1.1 mrg rm -f Makefile.$$
233 1.1 mrg }
234 1.1 mrg
235 1.1 mrg
236 1.1 mrg # Whenever we update the tree or install a patch, we may be modifying
237 1.1 mrg # this script. By re-execing it, we ensure that the appropriate
238 1.1 mrg # dependencies and rules will be used.
239 1.1 mrg touch_files_reexec () {
240 1.1 mrg chat "Adjusting file timestamps"
241 1.1 mrg exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
242 1.1 mrg }
243 1.1 mrg
244 1.1 mrg # This functions applies a patch to an existing tree.
245 1.1 mrg apply_patch () {
246 1.1 mrg if [ -f "$1" ]; then
247 1.1 mrg echo "Applying patch file $1"
248 1.1 mrg case $1 in
249 1.1 mrg *gz)
250 1.1 mrg gzip -d -c "$1" | patch -p1 ;;
251 1.1 mrg *bz2)
252 1.1 mrg bzip2 -d -c "$1" | patch -p1 ;;
253 1.1 mrg *)
254 1.1 mrg patch -p1 < "$1";;
255 1.1 mrg esac
256 1.1 mrg fi
257 1.1 mrg touch_files_reexec
258 1.1 mrg }
259 1.1 mrg
260 1.1 mrg # Check whether this indeed looks like a local tree.
261 1.1.1.14 mrg if [ ! -f gcc/reload.cc ]; then
262 1.1 mrg echo "This does not seem to be a GCC tree!"
263 1.1 mrg exit
264 1.1 mrg fi
265 1.1 mrg
266 1.1 mrg case "$1" in
267 1.1 mrg --silent)
268 1.1 mrg silent=t
269 1.1 mrg shift
270 1.1 mrg ;;
271 1.1 mrg esac
272 1.1 mrg
273 1.1 mrg case "$1" in
274 1.1 mrg # First of all, check whether we are going to process a patch.
275 1.1 mrg --patch)
276 1.1 mrg if test "$#" != 2; then
277 1.1 mrg echo "$1" expects only one argument >&2
278 1.1 mrg exit 1
279 1.1 mrg fi
280 1.1 mrg apply_patch "${2}"
281 1.1 mrg exit $?
282 1.1 mrg ;;
283 1.1 mrg
284 1.1 mrg --touch)
285 1.1 mrg if test "$#" != 1; then
286 1.1 mrg echo "$1" does not expect any argument >&2
287 1.1 mrg exit 1
288 1.1 mrg fi
289 1.1 mrg touch_files
290 1.1 mrg exit $?
291 1.1 mrg ;;
292 1.1 mrg
293 1.1 mrg --list)
294 1.1 mrg if test "$#" != 1; then
295 1.1 mrg echo "$1" does not expect any argument >&2
296 1.1 mrg exit 1
297 1.1 mrg fi
298 1.1 mrg files_and_dependencies | sed 's/ /: /'
299 1.1 mrg exit $?
300 1.1 mrg ;;
301 1.1 mrg
302 1.1 mrg --help)
303 1.1 mrg sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
304 1.1 mrg \
305 1.1 mrg
306 1.1 mrg p
307 1.1 mrg }' \
308 1.1 mrg -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
309 1.1 mrg exit $?
310 1.1 mrg ;;
311 1.1 mrg
312 1.1 mrg esac
313 1.1 mrg
314 1.1.1.2 mrg # Check for known version control systems.
315 1.1.1.11 mrg if [ -d .git ] || [ -f .git ]; then
316 1.1.1.2 mrg GCC_GIT=${GCC_GIT-${GIT-git}}
317 1.1.1.2 mrg vcs_type="git"
318 1.1.1.2 mrg elif [ -d .hg ]; then
319 1.1.1.2 mrg GCC_HG=${GCC_HG-${HG-hg}}
320 1.1.1.2 mrg vcs_type="hg"
321 1.1.1.2 mrg elif [ -d .svn ]; then
322 1.1.1.2 mrg GCC_SVN=${GCC_SVN-${SVN-svn}}
323 1.1.1.2 mrg vcs_type="svn"
324 1.1.1.2 mrg else
325 1.1.1.2 mrg echo "This does not seem to be a GCC GIT/HG/SVN tree!"
326 1.1 mrg exit
327 1.1 mrg fi
328 1.1 mrg
329 1.1 mrg # Check command-line options
330 1.1 mrg if [ x"${1}"x = x"--nostdflags"x ]; then
331 1.1 mrg shift
332 1.1 mrg else
333 1.1 mrg set -- $UPDATE_OPTIONS ${1+"$@"}
334 1.1 mrg fi
335 1.1 mrg
336 1.1.1.2 mrg case $vcs_type in
337 1.1.1.2 mrg git)
338 1.1.1.2 mrg chat "Updating GIT tree"
339 1.1.1.2 mrg
340 1.1.1.2 mrg $GCC_GIT diff --quiet --exit-code HEAD
341 1.1.1.2 mrg if [ $? -ne 0 ]; then
342 1.1.1.2 mrg echo "Attempting to update a dirty git tree!" >&2
343 1.1.1.2 mrg echo "Commit or stash your changes first and retry." >&2
344 1.1.1.2 mrg exit 1
345 1.1.1.2 mrg fi
346 1.1.1.2 mrg
347 1.1.1.2 mrg $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
348 1.1.1.2 mrg if [ $? -ne 0 ]; then
349 1.1.1.2 mrg (touch_files_reexec)
350 1.1.1.2 mrg echo "git pull of full tree failed." >&2
351 1.1.1.2 mrg exit 1
352 1.1.1.2 mrg fi
353 1.1.1.2 mrg
354 1.1.1.14 mrg # Open-coded version of "git gcc-descr" from contrib/gcc-git-customization.sh
355 1.1.1.14 mrg revision=`$GCC_GIT log -n1 --pretty=tformat:%h`
356 1.1.1.14 mrg r=`$GCC_GIT describe --all --match 'basepoints/gcc-[0-9]*' HEAD \
357 1.1.1.14 mrg | sed -n 's,^\(tags/\)\?basepoints/gcc-\([0-9]\+\)-\([0-9]\+\)-g[0-9a-f]*$,r\2-\3,p;s,^\(tags/\)\?basepoints/gcc-\([0-9]\+\)$,r\2-0,p'`;
358 1.1.1.15 mrg if test -n "$r"; then
359 1.1.1.14 mrg o=`$GCC_GIT config --get gcc-config.upstream`;
360 1.1.1.14 mrg rr=`echo $r | sed -n 's,^r\([0-9]\+\)-[0-9]\+\(-g[0-9a-f]\+\)\?$,\1,p'`;
361 1.1.1.14 mrg if $GCC_GIT rev-parse --verify --quiet ${o:-origin}/releases/gcc-$rr >/dev/null; then
362 1.1.1.14 mrg m=releases/gcc-$rr;
363 1.1.1.14 mrg else
364 1.1.1.14 mrg m=master;
365 1.1.1.14 mrg fi;
366 1.1.1.14 mrg if $GCC_GIT merge-base --is-ancestor HEAD ${o:-origin}/$m; then
367 1.1.1.14 mrg revision=${r}-g${revision};
368 1.1.1.14 mrg fi
369 1.1.1.14 mrg fi
370 1.1.1.2 mrg branch=`$GCC_GIT name-rev --name-only HEAD || :`
371 1.1.1.15 mrg ;;
372 1.1.1.2 mrg
373 1.1.1.2 mrg hg)
374 1.1.1.2 mrg chat "Updating HG tree"
375 1.1.1.2 mrg
376 1.1.1.2 mrg # Add -q so untracked files aren't listed.
377 1.1.1.2 mrg if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
378 1.1.1.2 mrg echo "Attempting to update a dirty hg tree!" >&2
379 1.1.1.2 mrg echo "Commit or revert your changes first and retry." >&2
380 1.1.1.2 mrg exit 1
381 1.1.1.2 mrg fi
382 1.1.1.2 mrg
383 1.1.1.2 mrg # Check for mq extension. mq patches must be popped so tip has
384 1.1.1.2 mrg # been converted from the SVN tree.
385 1.1.1.2 mrg if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
386 1.1.1.2 mrg # FIXME: Perhaps pop queue instead? We could do that since we
387 1.1.1.2 mrg # know the tree is clean.
388 1.1.1.2 mrg echo "Attempting to update hg tree with mq patches applied!" >&2
389 1.1.1.2 mrg echo "Pop your patches first and retry." >&2
390 1.1.1.2 mrg exit 1
391 1.1.1.2 mrg fi
392 1.1.1.2 mrg
393 1.1.1.2 mrg # Update tree, but make sure to only pull the default branch.
394 1.1.1.2 mrg # Otherwise all branches in the upstream repo are added, even if
395 1.1.1.2 mrg # only a single one has been cloned.
396 1.1.1.2 mrg $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
397 1.1.1.2 mrg if [ $? -ne 0 ]; then
398 1.1.1.2 mrg (touch_files_reexec)
399 1.1.1.2 mrg echo "hg pull of full tree failed." >&2
400 1.1.1.2 mrg exit 1
401 1.1.1.2 mrg fi
402 1.1.1.2 mrg
403 1.1.1.2 mrg # Update tree. Needs to be done separately from pull so
404 1.1.1.2 mrg # gcc_update -rREV works.
405 1.1.1.2 mrg $GCC_HG update ${silent+-q} ${1+"$@"}
406 1.1.1.2 mrg if [ $? -ne 0 ]; then
407 1.1.1.2 mrg (touch_files_reexec)
408 1.1.1.2 mrg echo "hg update of full tree failed." >&2
409 1.1.1.2 mrg exit 1
410 1.1.1.2 mrg fi
411 1.1.1.2 mrg
412 1.1.1.2 mrg # Extract SVN revision corresponding to parents, as stored by
413 1.1.1.2 mrg # hg convert. Before hg 1.4.3, there's no template keyword
414 1.1.1.2 mrg # corresponding to the extra: tag, so need to use hg log --debug
415 1.1.1.2 mrg # to extract the info.
416 1.1.1.2 mrg parents=`$GCC_HG parents --template '{rev}'`
417 1.1.1.2 mrg convert_revision=`$GCC_HG log --debug -r$parents | \
418 1.1.1.2 mrg sed -ne "/^extra:.*convert_revision=svn:/ {
419 1.1.1.2 mrg s%^[^/]*/%%
420 1.1.1.2 mrg p
421 1.1.1.2 mrg }"`
422 1.1.1.2 mrg revision=`echo $convert_revision | sed -e 's/.*@//'`
423 1.1.1.2 mrg branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
424 1.1.1.2 mrg ;;
425 1.1.1.2 mrg
426 1.1.1.2 mrg svn)
427 1.1.1.2 mrg chat "Updating SVN tree"
428 1.1.1.2 mrg
429 1.1.1.2 mrg $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
430 1.1.1.2 mrg if [ $? -ne 0 ]; then
431 1.1.1.2 mrg (touch_files_reexec)
432 1.1.1.2 mrg echo "SVN update of full tree failed." >&2
433 1.1.1.2 mrg exit 1
434 1.1.1.2 mrg fi
435 1.1.1.2 mrg
436 1.1.1.2 mrg revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
437 1.1.1.2 mrg branch=`$GCC_SVN info | sed -ne "/^URL:/ {
438 1.1.1.2 mrg s,.*/trunk,trunk,
439 1.1.1.2 mrg s,.*/branches/,,
440 1.1.1.2 mrg s,.*/tags/,,
441 1.1.1.2 mrg p
442 1.1.1.2 mrg }"`
443 1.1.1.2 mrg ;;
444 1.1.1.2 mrg esac
445 1.1 mrg
446 1.1 mrg rm -f LAST_UPDATED gcc/REVISION
447 1.1 mrg {
448 1.1.1.2 mrg date
449 1.1.1.2 mrg echo "`TZ=UTC date` (revision $revision)"
450 1.1 mrg } > LAST_UPDATED
451 1.1.1.14 mrg echo "[$branch $revision]" > gcc/REVISION
452 1.1 mrg
453 1.1 mrg touch_files_reexec
454